let object;
let groupViewLink;
$(document).ready(function () {
    let userEmail = $('#userEmail').html().trim();
    let projectName = $('#projectName').html().trim();
    groupViewLink = $('#groupView');
    groupViewLink.hide();
    fillTasks(projectName, userEmail);
    groupViewLink.on('click', function () {
        location.href = "../groupfinding/view-groups.jsp?projectName=" + projectName;
    });
});

function fillTasks(projectName, userEmail) {
    $.ajax({
        url: '../rest/tasks/user/' + encodeURI(userEmail) + '/project/' + projectName,
        headers: {
            "Content-Type": "application/json",
            "Cache-Control": "no-cache"
        },
        type: 'GET',
        success: function (response) {
            object = fillObjectWithTasks(response);
            for (let task in object) {
                let tmplObject = fitObjectInTmpl(object[task]);
                switch (tmplObject.taskProgress) {
                    case "FINISHED":
                        $('#finishedTaskTemplate').tmpl(tmplObject).appendTo('#listOfTasks');
                        break;
                    case "INPROGRESS":
                        $('#inProgressTaskTemplate').tmpl(tmplObject).appendTo('#listOfTasks');
                        break;
                    case "JUSTSTARTED":
                        $('#taskTemplate').tmpl(tmplObject).appendTo('#listOfTasks');
                        break;
                    default:
                        break;
                }
            }
        },
        error: function (a) {
        }
    });
}

function fitObjectInTmpl(object) {
    let result = {
        taskType: "",
        infoText: "",
        phase: "",
        headLine: "",
        solveTaskWith: "",
        helpLink: "",
        timeFrame: "",
        taskData: object.taskData,
        taskProgress: object.progress,
        inCardSolver: "",
    };

    if (object.taskType !== "INFO") {
        if (object.groupTask !== 0) {
            result.taskType = "grouptask"
        } else {
            result.taskType = "usertask"
        }
    } else {
        result.taskType = "infotask"
    }
    switch (object.phase) {
        case "CourseCreation":
            result.phase = "card-draft";
            result.headLine = "Projektstart";
            break;
        case "GroupFormation":
            result.phase = "card-grouping";
            result.headLine = "Gruppenbildung";
            break;
        case "DossierFeedback":
            groupViewLink.show();
            result.phase = "card-feedback";
            result.headLine = "Entwurfsphase";
            break;
        case "Execution":
            groupViewLink.show();
            result.phase = "card-execution";
            result.headLine = "Durchführung";
            break;
        case "Assessment":
            groupViewLink.show();
            result.phase = "card-assessment";
            result.headLine = "Bewertungsphase";
            break;
        case "Projectfinished":
            groupViewLink.show();
            result.phase = "card-grades";
            result.headLine = "Projektabschluss";
            break;
        default:
            result.phase = "";
    }
    if (object.deadline != null) {
        let daysLeft = Math.round((object.deadline - Date.now()) / 1000 / 60 / 60 / 24);
        if (daysLeft >= 1)
            result.timeFrame = "<div class='status icon'><p>Noch " + daysLeft + " Tage Zeit</p></div>";
        else
            result.timeFrame = "<div class='status alert icon'><p>Du bist zu spät.</p></div>";
    } else {
        result.timeFrame = "";
    }
    switch (object.taskName) {
        case "WAIT_FOR_PARTICPANTS":
            result.infoText = waitForParticipantsInfoText(object);
            switch (object.taskData.gfm) {
                case "UserProfilStrategy":
                    if (countMissingStudents(object) > 0) {
                        result.inCardSolver = "resizeGroup";
                    }
                    break;
            }
            break;
        case "BUILD_GROUPS":
            result.infoText = "Erstellen Sie die Gruppen.";
            break;
        case "CLOSE_GROUP_FINDING_PHASE":
            result.infoText = "Gehen Sie zur nächsten Phase über.";
            break;
        case "WAITING_FOR_GROUP":
            result.infoText = "[STUDENT] Die Arbeitsgruppen werden gebildet. Sie werden informiert, wenn es so weit" +
                " ist.";
            break;
        case "UPLOAD_DOSSIER":
            result.infoText = "Legen Sie ein Dossier an.";
            break;
        case "ANNOTATE_DOSSIER":
            result.infoText = "Annotieren Sie ihr Dossier.";
            break;
        case "GIVE_FEEDBACK":
            result.infoText = "[STUDENT] Geben Sie ein Feedback .....";
            if (object.taskData === null) {
                result.infoText += "nachdem ein weiterer Teilnehmer ein Dossier abgegeben hat."
            }
            break;
        case "SEE_FEEDBACK":
            result.infoText = "Sie erhielten Feedback zu Ihrem Dossier.";
            break;
        case "WAITING_FOR_STUDENT_DOSSIERS":
            result.infoText = "Studierende legen nun ein Dossier an und" +
                " geben sich gegenseitig Feedback.";
            break;
        case "CLOSE_DOSSIER_FEEDBACK_PHASE":
            let count = object.taskData.length;
            if (count <= 3) {
                result.infoText = "Es fehlen noch die Feedbacks der Gruppe/n ";
                for (let i = 0; i < object.taskData.length; i++) {
                    for (let j = 0; j < object.taskData[i].members.length; j++) {
                        result.infoText += object.taskData[i].members[j].name;
                        if (j < object.taskData[i].members.length - 1) {
                            result.infoText += ", "
                        }
                    }
                    if (i < object.taskData.length - 1) {
                        result.infoText += " und "
                    }
                }
            } else {
                result.infoText = "Noch haben nicht alle Studenten ihren Peers ein Feedback gegeben.";
            }
            break;
        case "WAIT_FOR_REFLECTION":
            result.infoText = "Nun arbeiten die Studenten an ihren Projekten.";
            break;
        case "EDIT_FORMED_GROUPS":
            result.infoText = "Die Gruppen wurden vom Algorithmus gebildet. Sie können noch manuell" +
                " editiert werden."; // hier müsste noch ein Link eingefügt werden, zur manuellen Gruppenbildung
            break;
        case "CONTACT_GROUP_MEMBERS":
            result.infoText = "Sagen sie hallo zu ihren Gruppenmitgliedern über den Chat.";
            break;
        case "OPTIONAL_PORTFOLIO_ENTRY":
            result.infoText = "E-Portfolio";
            break;
        default:
            result.infoText = "";
    }
    if (object.taskType.includes("LINKED")) {
        switch (object.taskName) {
            case "WAIT_FOR_PARTICPANTS":
                if (object.taskData.participantCount.participants >= object.taskData.participantCount.participantsNeeded) {
                    result.infoText = "Sehen Sie sich den Gruppenvorschlag des Algorithmus an oder " +
                        "warten Sie auf weitere Teilnehmer. Die Gruppen sind noch nicht final gespeichert.\n" +
                        "Es sind bereits " + object.taskData.participantCount.participants + " Studenten eingetragen.";
                    result.solveTaskWith = "Gruppen einsehen";
                    switch (object.taskData.gfm) {
                        default:
                            result.solveTaskWithLink = "initializeGroups('" + object.projectName + "');";
                            break;
                    }
                } else {
                    result.infoText = waitForParticipantsInfoText(object);
                }
                break;
            case "CLOSE_GROUP_FINDING_PHASE":
                result.solveTaskWith = "Entwurfsphase starten";
                result.solveTaskWithLink = "closePhase(\'" + object.phase + "\', \'" + object.projectName + "\');";
                break;
            case "UPLOAD_DOSSIER":
                result.solveTaskWith = "Bearbeite / Erstelle Dossier";
                result.solveTaskWithLink = "redirect(\'../annotation/upload-unstructured-dossier.jsp?projectName=" + object.projectName + "&contributionCategory=Dossier" + "\')";
                break;
            case "CREATE_QUIZ":
                result.solveTaskWith = "Erstelle ein Quiz";
                result.solveTaskWithLink = "redirect(\'../assessment/create-quiz.jsp?projectName=" + object.projectName + "\')";
                break;
            case "WRITE_EJOURNAL":
                result.solveTaskWith = "Lege ein EJournal an";
                result.solveTaskWithLink = "redirect(\'../journal/create-journal.jsp?projectName=" + object.projectName + "\')";
                break;
            case "ANNOTATE_DOSSIER":
                result.solveTaskWith = "Annotiere das Dossier";
                result.solveTaskWithLink = "redirect(\'../annotation/create-unstructured-annotation.jsp?" + $.param({
                    projectName: object.projectName,
                    submissionId: object.taskData.fullSubmissionId,
                    contributionCategory: "Dossier"
                }) + "\')";
                break;
            case "FINALIZE_DOSSIER":
                result.solveTaskWith = "Finalisiere das Dossier";
                result.solveTaskWithLink = "redirect(\'../annotation/create-unstructured-annotation.jsp?projectName=" + object.projectName + "&submissionId=" + object.taskData.fullSubmissionId + "\')";
                break;
            case "FINALIZE_EJOURNAL":
                result.solveTaskWith = "Finalisiere dein EJournal";
                result.solveTaskWithLink = "redirect(\'../journal/edit-description.jsp?projectName=" + object.projectName + "\')";
                break;
            case "CLOSE_DOSSIER_FEEDBACK_PHASE":
                result.taskData = object.taskData;
                if (result.taskData.length === 0) {
                    result.solveTaskWith = "Reflexionsphase starten";
                    result.solveTaskWithLink = "closePhase(\'" + object.phase + "\', \'" + object.projectName + "\');";
                } else {
                    if (result.taskData.length <= 3) {  //todo: probably its better to have a percentage of all participants as constraint

                    }
                }

                break;
            case "ASSESSMENT":
                result.solveTaskWith = "Starte Bewertung";
                result.solveTaskWithLink = "redirect(\'../assessment/assess-work.jsp?projectName=" + object.projectName + "\')";
                break;
            case "GIVE_FEEDBACK":
                if (object.taskData !== null) {
                    result.solveTaskWith = "Geben Sie ein Feedback";
                    result.solveTaskWithLink = "redirect(\'../annotation/give-feedback.jsp?" +
                        "projectName=" + object.projectName +
                        "&fullSubmissionId=" + object.taskData.fullSubmission.id + "&category=" + object.taskData.category + "\')";
                }

                break;
            case "SEE_FEEDBACK":
                if (object.taskData !== null) {
                    result.solveTaskWith = "zum Feedback";
                    result.solveTaskWithLink = "redirect(\'../annotation/see-feedback.jsp?" +
                        "projectName=" + object.projectName +
                        "&fullSubmissionId=" + object.taskData.fullSubmissionId +
                        "&category=" + object.taskData.category +
                        "&contribution=DOSSIER\')";
                }
                break;

            case "OPTIONAL_PORTFOLIO_ENTRY":
                result.solveTaskWith = "Erstelle einen Portfolio-Eintrag (optional)";
                result.solveTaskWithLink = "redirect(\'../annotation/upload-unstructured-dossier.jsp?" + $.param({
                    projectName: object.projectName,
                    contributionCategory: "Portfolio",
                    personal: "true"
                }) + "\')";
                break;
            default:
                result.solveTaskWith = null;

        }
    }

    if (object.progress === "FINISHED") {
        if (object.taskName === "WAIT_FOR_PARTICPANTS") {
            result.infoText = "Gruppen sind final gespeichert. \n" +
                "Es sind bereits " + object.taskData.participantCount.participants + " Studenten eingetragen.";
        }
        if (object.taskName === "GIVE_FEEDBACK") {
            result.infoText = "Sie können weiterhin ihr Feedback editieren";
            if (object.taskData !== null) {
                result.solveTaskWith = "Geben Sie ein Feedback";
                result.solveTaskWithLink = "redirect(\'../annotation/give-feedback.jsp?" +
                    "projectName=" + object.projectName +
                    "&fullSubmissionId=" + object.taskData.fullSubmission.id + "&category=" + object.taskData.category + "\')";
            }
        }
        if (object.taskName === "ANNOTATE_DOSSIER" || object.taskName === "UPLOAD_DOSSIER") {
            result.solveTaskWith = "";
            result.solveTaskWithLink = "";
        }
        if (object.taskName.includes("CLOSE")) {
            result.taskProgress = "FINISHED";
            result.infoText = object.phase;
            let created = new Date(object.eventCreated);
            let deadline = new Date(object.deadline);
            result.timeFrame = "<p>" + created.getDate() + "." + (created.getMonth() + 1) + "." + created.getFullYear() +
                " bis " + deadline.getDate() + "." + (deadline.getMonth() + 1) + "." + deadline.getFullYear() + "</p>";
            return result;
        } else {
            result.timeFrame = "";
        }
        result.taskProgress = "FINISHED";
        return result;
    }

    return result;
}

function fillObjectWithTasks(response) {
    let tempObject = [];
    let first = true;
    for (let task in response) {
        let headLine = "";
        switch (response[task].phase) {
            case ("card-grouping"):
                break;
        }
        if (response.hasOwnProperty(task)) {
            tempObject.push({
                taskType: response[task].taskType,  //
                taskData: response[task].taskData,
                taskName: response[task].taskName,  //
                hasRenderModel: response[task].hasRenderModel,
                eventCreated: response[task].eventCreated,
                deadline: response[task].deadline, //
                groupTask: response[task].groupTask,//
                importance: response[task].importance,
                phase: response[task].phase,  //
                headLine: "",
                link: response[task].link,  //
                userEmail: response[task].userEmail,
                projectName: response[task].projectName,
                progress: response[task].progress,
                current: first
            });
            if (first) {
                first = false;
            }
        }
    }

    return tempObject;
}

function redirect(url) {
    location.href = url;
}

function closePhase(phase, projectName) {
    let innerurl = '../rest/phases/' + phase + '/projects/' + projectName + '/end';
    $.ajax({
        url: innerurl,
        headers: {
            "Content-Type": "application/json",
            "Cache-Control": "no-cache"
        },
        type: 'GET',
        success: function () {
            location.reload();
        },
        error: function (a) {
        }


    })
}

function initializeGroups(projectName) {
    let projq = new RequestObj(1, "/group", "/all/projects/?", [projectName], []);
    serverSide(projq, "GET", function (response) {
        redirect("../groupfinding/create-groups-manual.jsp?projectName=" + projectName);
    });
}

function countMissingStudents(object) {
    return object.taskData.participantCount.participantsNeeded - object.taskData.participantCount.participants;
}

function waitForParticipantsInfoText(object) {
    let result = "Warten Sie auf die Anmeldungen der Studenten.\n" +
        "Es sind bereits " + object.taskData.participantCount.participants + " Studenten eingetragen.";
    if (object.taskData.participantCount.participants === 0) {
        result = " Es gibt noch keine Teilnehmer.";
    }
    if (countMissingStudents(object) > 0) {
        if (countMissingStudents(object) === 1) {
            result += " Um Gruppen bilden zu können, fehlt noch ein Student.";
        } else {
            result += " Um Gruppen bilden zu können, fehlen noch " + countMissingStudents(object) + " Studenten.";
        }
    }
    return result
}

function resizeGroup(){
    $.ajax({
        url: '../rest/project/update/project/' + $('#projectName').html().trim() + '/groupSize/' + $('#userCount').val().trim(),
        headers: {
            "Cache-Control": "no-cache"
        },
        type: 'POST',
        success: function (response) {
            location.reload();
        }
    });
}

function updateGroupSizeView(){
    let userCount = parseInt($('#userCount').val().trim());
    $('#groupSize').html(userCount*(userCount-1));
}